unit FrmTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Grids, AdvObj, BaseGrid, AdvGrid;

type
  TForm1 = class(TForm)
    AdvStringGrid1: TAdvStringGrid;
    BtnNormal: TButton;
    BtnAddSpace: TButton;
    procedure FormCreate(Sender: TObject);
    procedure AdvStringGrid1GetCellColor(Sender: TObject; ARow, ACol: Integer;
      AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure BtnNormalClick(Sender: TObject);
    procedure BtnAddSpaceClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AdvStringGrid1GetCellColor(Sender: TObject;
  ARow, ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
  ABrush.color := 0;
  if (ARow = 0) or (ACol = 0) then
  begin
    AFont.color := rgb(152, 254, 157);
  end
  else
  begin
    AFont.color := rgb(255, 255, 255);
  end;
end;

procedure TForm1.BtnAddSpaceClick(Sender: TObject);
begin
  with AdvStringGrid1 do
  begin
    AutoSizeCol(3);

    // if we add some more space
    colwidths[3] := colwidths[3] + 50;
  end;
end;

procedure TForm1.BtnNormalClick(Sender: TObject);
begin
  with AdvStringGrid1 do
  begin
    AutoSizeCol(3);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  FFontSize: Integer;
  i: Integer;
  ARow: Integer;
const
  cstQuestions: array [0 .. 2] of string = ('Name', 'Tel', 'email');

begin

  with AdvStringGrid1 do
  begin
    EnableHTML := false;
    UseHTMLHints := false;
    SaveWithHTML := false;
    HTMLHint := false;

    EditWithTags := true;

    fixedrows := 1;
    rowcount := 5;

    Cells[0, 0] := 'Nr';
    Cells[1, 0] := 'Question';
    Cells[2, 0] := 'Value';
    Cells[3, 0] := 'Checked';

    for ARow := low(cstQuestions) to high(cstQuestions) do
    begin
      Cells[0, ARow + 1] := '1';
      Cells[1, ARow + 1] := cstQuestions[ARow];
      Cells[2, ARow + 1] := '';
      Cells[3, ARow + 1] := stringofchar(' ', 5) + cstQuestions[ARow];

      AddCheckBox(3, ARow + 1, true, false);
      SetCheckBoxState(3, ARow + 1, true);
    end;

    AutoSizeCol(3);

    Options := Options + [goRangeSelect, goEditing, goTabs]; // , goRowSelect];

    // { basic grid settings }
    DoubleBuffered := true;

  end;

end;

end.
